#!/bin/bash


JIKESRVM_DIST='/home/jsartor/testPerfAnalysis/jikes/JikesRVM-3.1.3/dist' #path to the dist directory; dist will have a directory for each collector+compiler configuration
DATA_DIR='/home/jsartor/testPerfAnalysis/jikes/' #path to ProbeEssential.jar and dacapo*.jar

APPS_912_BACH=('avrora' 'jython' 'luindex' 'lusearch' 'pmd' 'sunflow' 'xalan') #'eclipse' 'fop'
APPS_200610_MR2=('fop' 'eclipse' 'antlr' 'bloat' 'hsqldb')

declare -A MIN_HEAPS

bmark=$1
collector=$2
heap_multiplier=$3
times2run=$4

bach='false'
mr2='false'

if [ $collector = 'GenImmix' ]; then
	#MIN_HEAPS=( [fop]=35 [antlr]=30 [luindex]=30 [bloat]=40 [avrora]=30 [xalan]=40 [pmd]=55 [lusearch]=30 [sunflow]=30 [eclipse]=84 [jython]=90 )	
    MIN_HEAPS=( [avrora]=18 [jython]=53  [luindex]=18 [lusearch]=19 [pmd]=47 [sunflow]=24 [xalan]=24 )
elif [ $collector = 'Immix' ]; then
#        MIN_HEAPS=( [fop]=35 [antlr]=30 [luindex]=30 [bloat]=40 [avrora]=30 [xalan]=40 [pmd]=55 [lusearch]=30 [sunflow]=30 [eclipse]=84 [jython]=100 )
    MIN_HEAPS=( [avrora]=27 [jython]=148  [luindex]=26 [lusearch]=24 [pmd]=88 [sunflow]=40 [xalan]=41 )  
elif [ $collector = 'MarkSweep' ]; then
        MIN_HEAPS=( [avrora]=20 [jython]=65 [luindex]=20 [lusearch]=18 [pmd]=52 [sunflow]=24 [xalan]=26 )
elif [ $collector = 'MarkCompact' ]; then
    MIN_HEAPS=( [avrora]=19 [jython]=55  [luindex]=18 [lusearch]=17 [pmd]=47 [sunflow]=21 [xalan]=24 ) 
elif [ $collector = 'SemiSpace' ]; then
    MIN_HEAPS=( [avrora]=31 [jython]=94  [luindex]=32 [lusearch]=28 [pmd]=82 [sunflow]=34 [xalan]=39 )
fi

if [ "$bmark" = 'dacapo' ]; then
	all_bmarks=${APPS_912_BACH[*]} #'fop' 'antlr' 'luindex' 'bloat' 'avrora' 'xalan' 'pmd' 'lusearch' 'sunflow')
else
	all_bmarks=($bmark)
fi

dir=FastAdaptive"$collector"_x86_64-linux

for bm in ${all_bmarks[@]}; do
	echo $bm
	for i in ${APPS_912_BACH[@]}; do
		if [ "$i" = "$bm" ]; then
			bach='true'
		fi
	done
	
	if [ "$bach" = 'false' ]; then
		for j in ${APPS_200610_MR2[@]}; do
			if [ "$j" = "$bm" ]; then
				mr2='true'
			fi
		done
	fi

	if [ "$bach" = 'true' ]; then
		probe='DacapoBachCallback'
		jar='dacapo-9.12-bach.jar'
	elif [ "$mr2" = 'true' ]; then
		probe='Dacapo2006Callback'
		jar='dacapo-2006-10-MR2.jar'
	fi

	heap=MIN_HEAPS[$bm]
	heap=$((heap * heap_multiplier))	

	echo $JIKESRVM_DIST/$dir/rvm -Xms"$heap"M -X:gc:boundedNursery=8M -X:gc:variableSizeHeap=false -Dprobes=MMTk  -X:gc:threads=2 -cp $DATA_DIR/ProbeEssential.jar:$DATA_DIR/$jar Harness -c $probe -n $times2run $bm

	$JIKESRVM_DIST/$dir/rvm -Xms"$heap"M -X:gc:boundedNursery=8M -X:gc:variableSizeHeap=false -Dprobes=MMTk  -X:gc:threads=2 -cp $DATA_DIR/ProbeEssential.jar:$DATA_DIR/$jar Harness -c $probe -n $times2run $bm > resultsNoReplay/C$collector-B$bm-H$heap_multiplier-I$times2run 2>&1
done
